
#include <stderror.mqh>
#include <stdlib.mqh>

extern double Stop_Variable   = 3.5;//multiply gap by this number for stoploss
extern double    Profit_Variable = 0.4;//takeprofit will be Fri close - spread - this number
extern double Lot_Size        = 0.01;
extern int    Magic_Number    = 44648;

bool   GapTrap, TradeSet, ShowComm;

bool weekDone = false;

double symspread;
double StopLoss, TakeProfit, gslv, open, gaps;

int LG;
int Var = 1;

double fridayClose;

int init()
{
   return(0);
}

int deinit()
{
   return(0);
}


bool closeFound = false;

int start()
{
    
    // Need to get the close here from Friday Night for current Symbol
   if (DayOfWeek() == 5)
      closeFound = false;
   
   if ((DayOfWeek() == 1) && (closeFound == false))
   {
      for(int i = 0; i <= 4; i++)
      {
         if(TimeDayOfWeek(Time[i]) == 5)
         {
            fridayClose = Close[i];
            Print("Friday Close = ", fridayClose);
            GapTrap = true;
            TradeSet = true;
            ShowComm = true;
            closeFound = true;
            break;
         }
      }

      if ((GapTrap == true) && (closeFound == true))
      {
         open = Bid;
         Print ("Current Monday Open = ", open);
         gaps = (open - fridayClose);
         Print ("Gap is = ", gaps);
         symspread = MarketInfo(Symbol(),MODE_SPREAD);

         if(gaps > 0)
         {
            gslv = gaps;
         }
         if(gaps < 0)
         {
            gslv = gaps * (-1);
         }

         GapTrap = false;
   
         if((gaps < 0) && (TradeSet == true))//we buy
         {
            // i.e. Market's opened Lower on Monday than on Friday
            StopLoss = open - (gslv * Stop_Variable);
            TakeProfit = open + (gslv * Profit_Variable) + (symspread * Point);
            Print("Long Order For ", Symbol(), "  StopLoss = ", StopLoss, " :TakeProfit = ", TakeProfit);
            SendLong(StopLoss, TakeProfit);
         }
    
         if((gaps > 0) && (TradeSet == true))//we sell
         {
            // i.e. Market's opened Higher on Monday than on Friday
            StopLoss = open + (gslv * Stop_Variable);
            TakeProfit = open - (gslv * Profit_Variable) + (symspread * Point); // fridayClose + (symspread*Point);
            Print("Short Order For ", Symbol(), " StopLoss = ", StopLoss, " TakeProfit = ", TakeProfit);
            SendShort(StopLoss, TakeProfit);
         }
   
         if(ShowComm == true)
         {
            Comment("\nGap =  ",gaps,"  Spread =  ",symspread,
                    "\n",
                    "\n",Symbol(),"  Open =  ",open,"  Close =  ",fridayClose,
                    "\n",
                    "\nStopLoss =  ",StopLoss,"  TakeProfit =  ",TakeProfit,
                    "\n",
                    "\ntst =  ",(MathRound((gslv * Stop_Variable)) * Point));
             ShowComm = false;
         } 
      }   
   }
   return(0);
}

int OTBM(int intMagic)//OrdersTotalByMagic
{
   int intCount=0;
   int intPOS=0;
   bool boolTerm=false;

   while(boolTerm==false)
   {
      if(OrderSelect(intPOS,SELECT_BY_POS))
      {
         if(OrderMagicNumber()==intMagic) intCount++;
         intPOS++;
      }
      else
         boolTerm=true;
   }
   return(intCount);
}
 

void SendLong(double SL, double TP)//Send Long
{
   if (OTBM(Magic_Number) ==0)
   {
      int err;
      OrderSend(Symbol(), OP_BUY, Lot_Size, Ask, 0, SL, TP, "GapTrading-Long", Magic_Number, 0, Green);
      err = GetLastError();
      if (err < 0)
         Print("             ERROR(",err,"):  ",ErrorDescription(err));
      Sleep(200);
      if (OTBM(Magic_Number) == 1)
      {
         TradeSet = false;
      }
   }
}


void SendShort(double SL, double TP)//Send Short
{
 if (OTBM(Magic_Number) ==0)
  {
   int err;
   OrderSend(Symbol(),OP_SELL,Lot_Size,Bid, 0, SL, TP, "GapTrading-Short", Magic_Number, 0, Red);
   err = GetLastError();
   if (err < 0)
      Print("             ERROR(",err,"):  ",ErrorDescription(err));
   Sleep(200);
   if (OTBM(Magic_Number) == 1)
    {
     TradeSet = false;
    }
  }
}
